/* ResultLine.c generated by valac 0.40.8, the Vala compiler
 * generated from ResultLine.vala, do not modify */

/*
 * Copyright (c) 2015 Peter Arnold
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_RESULT_LINE (result_line_get_type ())
#define RESULT_LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RESULT_LINE, ResultLine))
#define RESULT_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RESULT_LINE, ResultLineClass))
#define IS_RESULT_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RESULT_LINE))
#define IS_RESULT_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RESULT_LINE))
#define RESULT_LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RESULT_LINE, ResultLineClass))

typedef struct _ResultLine ResultLine;
typedef struct _ResultLineClass ResultLineClass;
typedef struct _ResultLinePrivate ResultLinePrivate;
enum  {
	RESULT_LINE_0_PROPERTY,
	RESULT_LINE_LINE_PROPERTY,
	RESULT_LINE_VARIABLE_NAME_PROPERTY,
	RESULT_LINE_VALUE_PROPERTY,
	RESULT_LINE_FULL_VALUE_PROPERTY,
	RESULT_LINE_NUM_PROPERTIES
};
static GParamSpec* result_line_properties[RESULT_LINE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
enum  {
	RESULT_LINE_CHANGED_SIGNAL,
	RESULT_LINE_DESTROY_SIGNAL,
	RESULT_LINE_NUM_SIGNALS
};
static guint result_line_signals[RESULT_LINE_NUM_SIGNALS] = {0};

struct _ResultLine {
	GObject parent_instance;
	ResultLinePrivate * priv;
};

struct _ResultLineClass {
	GObjectClass parent_class;
};

struct _ResultLinePrivate {
	gint _line;
	gchar* _variable_name;
	gchar* _value;
	gchar* _full_value;
	cairo_t* context;
	gint width;
};


static gpointer result_line_parent_class = NULL;

GType result_line_get_type (void) G_GNUC_CONST;
#define RESULT_LINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_RESULT_LINE, ResultLinePrivate))
ResultLine* result_line_new (gint line,
                             const gchar* name,
                             const gchar* value,
                             gint width);
ResultLine* result_line_construct (GType object_type,
                                   gint line,
                                   const gchar* name,
                                   const gchar* value,
                                   gint width);
void result_line_set_line (ResultLine* self,
                           gint value);
void result_line_set_variable_name (ResultLine* self,
                                    const gchar* value);
static void result_line_set_value (ResultLine* self,
                            const gchar* value);
gboolean result_line_set_value_with_notification (ResultLine* self,
                                                  const gchar* value);
const gchar* result_line_get_full_value (ResultLine* self);
static void result_line_set_full_value (ResultLine* self,
                                 const gchar* value);
void result_line_set_val (ResultLine* self,
                          const gchar* value);
void result_line_refresh_width (ResultLine* self,
                                gint width);
gint result_line_get_line (ResultLine* self);
const gchar* result_line_get_variable_name (ResultLine* self);
const gchar* result_line_get_value (ResultLine* self);
static void result_line_finalize (GObject * obj);
static void _vala_result_line_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_result_line_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


ResultLine*
result_line_construct (GType object_type,
                       gint line,
                       const gchar* name,
                       const gchar* value,
                       gint width)
{
	ResultLine * self = NULL;
	cairo_surface_t* source = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	self = (ResultLine*) g_object_new (object_type, NULL);
	result_line_set_line (self, line);
	result_line_set_variable_name (self, name);
	result_line_set_value (self, value);
	self->priv->width = width;
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_A8, 32, 32);
	source = _tmp0_;
	_tmp1_ = cairo_create (source);
	_cairo_destroy0 (self->priv->context);
	self->priv->context = _tmp1_;
	_tmp2_ = self->priv->context;
	cairo_set_font_size (_tmp2_, (gdouble) 16);
	_cairo_surface_destroy0 (source);
	return self;
}


ResultLine*
result_line_new (gint line,
                 const gchar* name,
                 const gchar* value,
                 gint width)
{
	return result_line_construct (TYPE_RESULT_LINE, line, name, value, width);
}


gboolean
result_line_set_value_with_notification (ResultLine* self,
                                         const gchar* value)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (value != NULL, FALSE);
	_tmp0_ = self->priv->_full_value;
	if (g_strcmp0 (value, _tmp0_) == 0) {
		result = FALSE;
		return result;
	}
	result_line_set_full_value (self, value);
	result_line_set_val (self, value);
	g_signal_emit (self, result_line_signals[RESULT_LINE_CHANGED_SIGNAL], 0);
	result = TRUE;
	return result;
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		offset = _tmp3_ + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		glong _tmp4_;
		_tmp4_ = string_length;
		g_return_val_if_fail (offset <= _tmp4_, NULL);
	}
	if (len < ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		len = _tmp5_ - offset;
	}
	_tmp6_ = string_length;
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp7_;
	return result;
}


void
result_line_set_val (ResultLine* self,
                     const gchar* value)
{
	cairo_text_extents_t extents = {0};
	cairo_t* _tmp0_;
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = self->priv->context;
	cairo_text_extents (_tmp0_, value, &_tmp1_);
	extents = _tmp1_;
	_tmp2_ = extents;
	_tmp3_ = _tmp2_.width;
	_tmp4_ = self->priv->width;
	if (((gint) _tmp3_) > _tmp4_) {
		gchar* tmp = NULL;
		gchar* _tmp5_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		_tmp5_ = g_strdup (value);
		tmp = _tmp5_;
		while (TRUE) {
			cairo_text_extents_t _tmp6_;
			gdouble _tmp7_;
			gint _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gchar* _tmp13_;
			cairo_t* _tmp14_;
			const gchar* _tmp15_;
			cairo_text_extents_t _tmp16_ = {0};
			_tmp6_ = extents;
			_tmp7_ = _tmp6_.width;
			_tmp8_ = self->priv->width;
			if (!(((gint) _tmp7_) > (2 * _tmp8_))) {
				break;
			}
			_tmp9_ = tmp;
			_tmp10_ = tmp;
			_tmp11_ = strlen (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = string_substring (_tmp9_, (glong) 0, (glong) (_tmp12_ / 2));
			_g_free0 (tmp);
			tmp = _tmp13_;
			_tmp14_ = self->priv->context;
			_tmp15_ = tmp;
			cairo_text_extents (_tmp14_, _tmp15_, &_tmp16_);
			extents = _tmp16_;
		}
		while (TRUE) {
			cairo_text_extents_t _tmp17_;
			gdouble _tmp18_;
			gint _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gchar* _tmp24_;
			cairo_t* _tmp25_;
			const gchar* _tmp26_;
			cairo_text_extents_t _tmp27_ = {0};
			_tmp17_ = extents;
			_tmp18_ = _tmp17_.width;
			_tmp19_ = self->priv->width;
			if (!(((gint) _tmp18_) > _tmp19_)) {
				break;
			}
			_tmp20_ = tmp;
			_tmp21_ = tmp;
			_tmp22_ = strlen (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = string_substring (_tmp20_, (glong) 0, (glong) (_tmp23_ - 1));
			_g_free0 (tmp);
			tmp = _tmp24_;
			_tmp25_ = self->priv->context;
			_tmp26_ = tmp;
			cairo_text_extents (_tmp25_, _tmp26_, &_tmp27_);
			extents = _tmp27_;
		}
		_tmp28_ = tmp;
		_tmp29_ = g_strconcat (_tmp28_, "...", NULL);
		_g_free0 (tmp);
		tmp = _tmp29_;
		_tmp30_ = tmp;
		result_line_set_value (self, _tmp30_);
		_g_free0 (tmp);
	} else {
		result_line_set_value (self, value);
	}
}


void
result_line_refresh_width (ResultLine* self,
                           gint width)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->width = width;
	_tmp0_ = self->priv->_full_value;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = self->priv->_full_value;
		result_line_set_val (self, _tmp1_);
	}
}


gint
result_line_get_line (ResultLine* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_line;
	result = _tmp0_;
	return result;
}


void
result_line_set_line (ResultLine* self,
                      gint value)
{
	g_return_if_fail (self != NULL);
	if (result_line_get_line (self) != value) {
		self->priv->_line = value;
		g_object_notify_by_pspec ((GObject *) self, result_line_properties[RESULT_LINE_LINE_PROPERTY]);
	}
}


const gchar*
result_line_get_variable_name (ResultLine* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_variable_name;
	result = _tmp0_;
	return result;
}


void
result_line_set_variable_name (ResultLine* self,
                               const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, result_line_get_variable_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_variable_name);
		self->priv->_variable_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, result_line_properties[RESULT_LINE_VARIABLE_NAME_PROPERTY]);
	}
}


const gchar*
result_line_get_value (ResultLine* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_value;
	result = _tmp0_;
	return result;
}


static void
result_line_set_value (ResultLine* self,
                       const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, result_line_get_value (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_value);
		self->priv->_value = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, result_line_properties[RESULT_LINE_VALUE_PROPERTY]);
	}
}


const gchar*
result_line_get_full_value (ResultLine* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_full_value;
	result = _tmp0_;
	return result;
}


static void
result_line_set_full_value (ResultLine* self,
                            const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, result_line_get_full_value (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_full_value);
		self->priv->_full_value = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, result_line_properties[RESULT_LINE_FULL_VALUE_PROPERTY]);
	}
}


static void
result_line_class_init (ResultLineClass * klass)
{
	result_line_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ResultLinePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_result_line_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_result_line_set_property;
	G_OBJECT_CLASS (klass)->finalize = result_line_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), RESULT_LINE_LINE_PROPERTY, result_line_properties[RESULT_LINE_LINE_PROPERTY] = g_param_spec_int ("line", "line", "line", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RESULT_LINE_VARIABLE_NAME_PROPERTY, result_line_properties[RESULT_LINE_VARIABLE_NAME_PROPERTY] = g_param_spec_string ("variable-name", "variable-name", "variable-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RESULT_LINE_VALUE_PROPERTY, result_line_properties[RESULT_LINE_VALUE_PROPERTY] = g_param_spec_string ("value", "value", "value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RESULT_LINE_FULL_VALUE_PROPERTY, result_line_properties[RESULT_LINE_FULL_VALUE_PROPERTY] = g_param_spec_string ("full-value", "full-value", "full-value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	result_line_signals[RESULT_LINE_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_RESULT_LINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	result_line_signals[RESULT_LINE_DESTROY_SIGNAL] = g_signal_new ("destroy", TYPE_RESULT_LINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
result_line_instance_init (ResultLine * self)
{
	self->priv = RESULT_LINE_GET_PRIVATE (self);
}


static void
result_line_finalize (GObject * obj)
{
	ResultLine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RESULT_LINE, ResultLine);
	_g_free0 (self->priv->_variable_name);
	_g_free0 (self->priv->_value);
	_g_free0 (self->priv->_full_value);
	_cairo_destroy0 (self->priv->context);
	G_OBJECT_CLASS (result_line_parent_class)->finalize (obj);
}


GType
result_line_get_type (void)
{
	static volatile gsize result_line_type_id__volatile = 0;
	if (g_once_init_enter (&result_line_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ResultLineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) result_line_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ResultLine), 0, (GInstanceInitFunc) result_line_instance_init, NULL };
		GType result_line_type_id;
		result_line_type_id = g_type_register_static (G_TYPE_OBJECT, "ResultLine", &g_define_type_info, 0);
		g_once_init_leave (&result_line_type_id__volatile, result_line_type_id);
	}
	return result_line_type_id__volatile;
}


static void
_vala_result_line_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ResultLine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_RESULT_LINE, ResultLine);
	switch (property_id) {
		case RESULT_LINE_LINE_PROPERTY:
		g_value_set_int (value, result_line_get_line (self));
		break;
		case RESULT_LINE_VARIABLE_NAME_PROPERTY:
		g_value_set_string (value, result_line_get_variable_name (self));
		break;
		case RESULT_LINE_VALUE_PROPERTY:
		g_value_set_string (value, result_line_get_value (self));
		break;
		case RESULT_LINE_FULL_VALUE_PROPERTY:
		g_value_set_string (value, result_line_get_full_value (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_result_line_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ResultLine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_RESULT_LINE, ResultLine);
	switch (property_id) {
		case RESULT_LINE_LINE_PROPERTY:
		result_line_set_line (self, g_value_get_int (value));
		break;
		case RESULT_LINE_VARIABLE_NAME_PROPERTY:
		result_line_set_variable_name (self, g_value_get_string (value));
		break;
		case RESULT_LINE_VALUE_PROPERTY:
		result_line_set_value (self, g_value_get_string (value));
		break;
		case RESULT_LINE_FULL_VALUE_PROPERTY:
		result_line_set_full_value (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



